/*
	sing.c -- minimal-storage sort (variant of "quickersort")
		
	CACM Algorithm 347 (Richard C. Singleton)
	See Harold Lorin, "Sorting and Sort Systems," A-42.

	Haven't had time to redo this; transliterated from FORTRAN.
*/

#include "demosort.h"

void
sing(char a[], int n, int speed_factor)
{
	char t, tt;
	int iu[16], il[16];
	int k;
	int l;
	int m;
	register int i, j;
	register int ij;

	m = 1;
	i = 1;
	j = n;
five:
	if (i >= j)
		goto seventy;
ten:
	if (slowdown(speed_factor) == 1)
		return;	/* user hit ctl-break */
	k = i;
	ij = (j + i) / 2;
	t = a[2 * (ij - 1)];
	if (a[2 * (i - 1)] <= t)
		goto twenty;
	a[2 * (ij - 1)] = a[2 * (i - 1)];
	a[2 * (i - 1)] = t;
	t = a[2 * (ij - 1)];
twenty:
	l = j;
	if (a[2 * (j - 1)] >= t)
		goto forty;
	a[2 * (ij - 1)] = a[2 * (j - 1)];
	a[2 * (j - 1)] = t;
	t = a[2 * (ij - 1)];
	if (a[2 * (i - 1)] <= t)
		goto forty;
	a[2 * (ij - 1)] = a[2 * (i - 1)];
	a[2 * (i - 1)] = t;
	t = a[2 * (ij - 1)];
	goto forty;
thirty:
	a[2 * (l - 1)] = a[2 * (k - 1)];
	a[2 * (k - 1)] = tt;
forty:
	--l;
	if (a[2 * (l - 1)] > t)
		goto forty;
	tt = a[2 * (l - 1)];
fifty:
	++k;
	if (a[2 * (k - 1)] < t)
		goto fifty;
	if (k <= l)
		goto thirty;
	if (l - i <= j - k)
		goto sixty;
	il[m - 1] = i;
	iu[m - 1] = l;
	i = k;
	++m;
	goto eighty;
sixty:
	il[m - 1] = k;
	iu[m - 1] = j;
	j = l;
	++m;
	goto eighty;
seventy:
	--m;
	if (!m)
		return;
	i = il[m - 1];
	j = iu[m - 1];
eighty:
	if (j - i >= 1)
		goto ten;
	if (i == 1)
		goto five;
	--i;
ninety:
	++i;
	if (i == j)
		goto seventy;
	t = a[2 * i];
	if (a[2 * (i - 1)] <= t)
		goto ninety;
	k = i;
hundred:
	a[2 * k] = a[2 * (k - 1)];
	--k;
	if (t < a[2 * (k - 1)])
		goto hundred;
	a[2 * k] = t;
	goto ninety;
}
